import { SimpleChanges, KeyValueDiffers } from '@angular/core';
import { NgZone, ElementRef } from '@angular/core';
import { OnDestroy, DoCheck, OnChanges, AfterViewInit } from '@angular/core';
import { EventEmitter } from '@angular/core';
import { Geometry, Position } from './perfect-scrollbar.interfaces';
import { PerfectScrollbarConfig, PerfectScrollbarConfigInterface } from './perfect-scrollbar.interfaces';
export declare class PerfectScrollbarDirective implements OnDestroy, DoCheck, OnChanges, AfterViewInit {
    private defaults;
    private zone;
    elementRef: ElementRef;
    private differs;
    private ps;
    private ro;
    private timeout;
    private configDiff;
    fxShow: boolean;
    fxHide: boolean;
    hidden: boolean;
    disabled: boolean;
    usePSClass: boolean;
    psPosStyle: string;
    runInsideAngular: boolean;
    config: PerfectScrollbarConfigInterface;
    oldConfig: PerfectScrollbarConfigInterface;
    reachEndX: EventEmitter<any>;
    reachEndY: EventEmitter<any>;
    reachStartX: EventEmitter<any>;
    reachStartY: EventEmitter<any>;
    constructor(defaults: PerfectScrollbarConfig, zone: NgZone, elementRef: ElementRef, differs: KeyValueDiffers);
    ngOnDestroy(): void;
    ngDoCheck(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    update(): void;
    geometry(prefix?: string): Geometry;
    position(absolute?: boolean): Position;
    scrollable(direction?: string): boolean;
    scrollTo(x: number, y?: number, speed?: number, emit?: boolean): void;
    scrollToX(x: number, speed?: number, emit?: boolean): void;
    scrollToY(y: number, speed?: number, emit?: boolean): void;
    scrollToTop(offset?: number, speed?: number, emit?: boolean): void;
    scrollToLeft(offset?: number, speed?: number, emit?: boolean): void;
    scrollToRight(offset?: number, speed?: number, emit?: boolean): void;
    scrollToBottom(offset?: number, speed?: number, emit?: boolean): void;
    animateScrolling(target: string, value: number, speed?: number, emit?: boolean): void;
}
